/* scientific.h
*
* Copyright (C) <2012>  Giuseppe Marco Randazzo <gmrandazzo@gmail.com>
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SCIENTIFIC_H
#define SCIENTIFIC_H

#ifdef __cplusplus
extern "C" {
#endif

#include <scientific/tensor.h>
#include <scientific/matrix.h>
#include <scientific/vector.h>
#include <scientific/list.h>

#include <scientific/numeric.h>
#include <scientific/algebra.h>
#include <scientific/statistic.h>
#include <scientific/metricspace.h>
#include <scientific/optimization.h>

#include <scientific/clustering.h>
#include <scientific/pca.h>
#include <scientific/cpca.h>
#include <scientific/pls.h>
#include <scientific/epls.h>
#include <scientific/upca.h>
#include <scientific/upls.h>
#include <scientific/mlr.h>
#include <scientific/lda.h>

#include <scientific/modelvalidation.h>


#ifdef __cplusplus
}
#endif

#endif
